
processor_resources:
  - label: flatten_json_array
    unarchive:
        format: json_array
  - label: flatten_metrics
    bloblang: |
      let columns = this.columns
      root = this.values.map_each(
        this.enumerated().map_each({
          $columns.index(this.index): this.value,
        }).fold({}, this.tally.merge(this.value))
      )

output_resources:
  - label: metrics_kafka_output
    kafka:
      ack_replicas:         false
      addresses:
        - ${KAFKA_BOOTSTRAP_SERVERS:localhost}:${KAFKA_BOOTSTRAP_PORT:9092}
      backoff:
        initial_interval:   1s
        max_elapsed_time:   30s
        max_interval:       5s
      client_id:            ${CONTAINER_NAME:localhost}-1
      compression:          ${KAFKA_COMPRESSION:none}
      max_msg_bytes:        52428800
      max_retries:          2
      max_in_flight:        20
      partitioner:          round_robin
      batching:
        count:              0
        byte_size:          0
        period:             "30ms"
      target_version:       2.8.0
      timeout:              5s
      topic:                ${METRICS_KAFKA_TOPIC:topic.pensando.lago.metrics}

rate_limit_resources:
  {{ range $i, $endpoint := .Values.config.psm -}}
  - label: {{ $i }}_rate
    local:
      count: 3
      interval: {{ $.Values.config.poll.interval }}
  {{ end }}